include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("Objects/DpCl.js");
include("servis/format.js");
include("servis/date.js");

var sTmpTbl = getTmpTableName();
var label = "CRM_ACTIVITY";
var oOrg;

function listLoad()
{
	this.title = UR("Активність контрагентів|Активность контрагентов");
	this.xmlGridFile = "orgactivity.xml";
	this.printLabel = label;
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.AfterUpdate = orgUpdate;
	if(extPar.org)
		this.oOrg.setCod(extPar.org);
	
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	if(extPar.date)
	{
		DATB.value = extPar.date;
		DATE.value = extPar.date;
	}
	
	this.recalc = recalc;
	setButton(BTNRECALC, this, "recalc");
	setValid(TYPEPER, onChangePeriod);
	setValid(DATB, date_valid);
	setValid(DATE, date_valid);
}

function listTitle()
{
	var sTitle = UR("Активність контрагентів|Активность контрагентов");
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	if(differ(dat1, new Date(1900, 0, 1))>0 && differ(dat1, d00)<0)
	{
		var sType = String(TYPEPER.value).trim();
		if(differ(dat1, dat2)==0)
			sTitle += " за "+ format("dd mmm yyyy", dat1);
		else if(sType=="TM" || sType=="LM")
			sTitle += " за "+ format("Mmm yyyy", dat1).toLowerCase();
		else if(sType=="TY")
			sTitle += " за "+ format("yyyy", dat1) + UR("р|г");
		else
			sTitle += ": "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");	
	}
	this.title = sTitle;
	return sTitle;
}

function orgUpdate()
{
	list.qryWhere = "1=1";
	if(oOrg.getCod())
		list.qryWhere = "FORG="+ oOrg.getCod();
	list.tblInit();
}

function listSrc()
{	
	this.qrySet("From", sTmpTbl
				, "Order", "FRATING desc, FORG"
				);	
}

function listDelAcc()
{
	return false;
}

function listMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		var talk = Number(tbl.getValue("FTALK"));
		grid.AddMenuItem("TALK", "Телефонні розмови \t("+ talk +")|Телефеонные разговоры \t("+ talk +")", talk==0);
		var mail = Number(tbl.getValue("FMAIL"));
		grid.AddMenuItem("MAIL", "Електронні повідомлення \t("+ mail +")|Электронные сообщения \t("+ mail +")", mail==0);
		var post = Number(tbl.getValue("FPOST"));
		grid.AddMenuItem("POST", "Поштова кореспонденція \t("+ post +")|Почтовая корреспонденция \t("+ post +")", post==0);
		var call = Number(tbl.getValue("FCALL"));
		grid.AddMenuItem("CALL", "Заявки \t("+ call +")|Заявки \t("+ call +")", call==0);
		var task = Number(tbl.getValue("FTASK"));
		grid.AddMenuItem("TASK", "Завдання \t("+ task +")|Задания \t("+ task +")", task==0);
		var topic = Number(tbl.getValue("FTOPIC"));
		grid.AddMenuItem("TOPIC", "Теми \t("+ topic +")|Темы \t("+ topic +")", topic==0);
		var ml = Number(tbl.getValue("FML"));
		grid.AddMenuItem("ML", "Маркетингові списки \t("+ ml +")|Маркетинговые списки \t("+ ml +")", ml==0);
		var response = Number(tbl.getValue("FRESPONSE"));
		grid.AddMenuItem("RESPONSE", "Відгуки \t("+ response +")|Отклики \t("+ response +")", response==0);
		var docs = Number(tbl.getValue("FDOCS"));
		grid.AddMenuItem("DOCS", "Усі документи \t("+ docs +")|Все документы \t("+ docs +")", docs==0);
		grid.AddMenuItem("", "");
		grid.AddMenuItem("VIEW", "Зведена інформація|Сводная информация");
	}
}

function listMenuRun(sID)
{
	var tbl = grid.getTable();
	if(!tbl)
		return;
	setPar("GLOBDAT1", DATB.value);
	setPar("GLOBDAT2", DATE.value);
	
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="VIEW" || sID=="EDIT")
	{
		var par =  new Object();
		par.org = tbl.getValue("FORG");	
		par.Fcl = 0;	
		showWindow("l_cl_info.xml", SW_MODAL, par);
		return true;
	}
	else if(sID=="TALK")
	{
		var par =  new Object();
		par.doc = "CRM.TR";
		par.org = tbl.getValue("FORG");			
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="MAIL")
	{
		var par =  new Object();
		par.doc = "MMSG";
		par.org = tbl.getValue("FORG");
		var orgID = tbl.getValue("FWID");		
		par.subWhere = " FWID in (select cnt.FID_DOC "
						+" from ^MAIL_CNT cnt "
						+" where cnt.FID_CP="+ sqlTo(orgID)
							+" or cnt.FID_CP in (select cp.FWID "
								+" from ^CL_ORGCP cp "
								+" where cp.FWID_CL="+ sqlTo(orgID) 
							+")"					
						+")";
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="POST")
	{
		var par =  new Object();
		par.doc = "POST";
		par.org = tbl.getValue("FORG");
		par.subWhere = " FSENDER="+ par.org +" or FRECIPIENT="+ par.org;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="CALL")
	{
		var par =  new Object();
		par.doc = "CALL";
		par.org = tbl.getValue("FORG");
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="TASK")
	{
		var par =  new Object();
		par.doc = "TASK";
		par.org = tbl.getValue("FORG");
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="TOPIC")
	{
		var par =  new Object();
		par.doc = "TOPIC";
		par.org = tbl.getValue("FORG");
		par.subWhere = " FORG="+ par.org;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="ML")
	{
		var par =  new Object();
		par.doc = "ML";
		par.org = tbl.getValue("FORG");
		par.subWhere = " FWID in (select r.FID_DOC from ^RML r where r.FORG="+ sqlTo(par.org) +") "
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="RESPONSE")
	{
		var par =  new Object();
		par.doc = "RESPONSE";
		par.org = tbl.getValue("FORG");
		par.subWhere = " FORG="+ par.org;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="DOCS")
	{
		var par =  new Object();		
		par.org = tbl.getValue("FORG");
		par.JID = "CRM";
		showWindow("l_crm.xml", SW_NOMODAL, par);
	}
}

function listMake()
{
	var sSQL = "create table "+ sTmpTbl 
				+" (FORG "+ sqlType("LONG") 
				+", FWID "+ sqlType("LONG")
				+", FTXT "+ sqlType("LONGTEXT")
				+", FADDR "+ sqlType("TEXT")
				+", FBLD "+ sqlType("TEXT")
				+", FAPART "+ sqlType("TEXT")
				+", FEMAIL "+ sqlType("TEXT")
				+", FPHONE "+ sqlType("TEXT")
				+", FRATING "+ sqlType("INT")	//обращения
				+", FTALK "+ sqlType("INT") 	//телефонные разговоры
				+", FTALK_IN "+ sqlType("INT") 	//телефонные разговоры входящие
				+", FTALK_TIME "+ sqlType("INT")//время телефонных разговоров
				+", FTALK_SUM "+ sqlType("DOUBLE")//сумма телефонных разговоров
				+", FMAIL "+ sqlType("INT") 	//электронные сообщения
				+", FMAIL_IN "+ sqlType("INT") 	//электронные сообщения входящие
				+", FPOST "+ sqlType("INT") 	//почтовая корреспонденция
				+", FPOST_IN "+ sqlType("INT") 	//почтовая корреспонденция входящая
				+", FCALL "+ sqlType("INT") 	//заявки
				+", FTASK "+ sqlType("INT") 	//задания
				+", FTASK_EXEC "+ sqlType("INT")//задания выполненные
				+", FTASK_TIME "+ sqlType("DOUBLE")//время выполнения
				+", FTOPIC "+ sqlType("INT") 	//топики
				+", FML "+ sqlType("INT") 		//маркетинговые списки
				+", FRESPONSE "+ sqlType("INT") //отклики
				+", FSF "+ sqlType("INT") 		//счета
				+", FPV "+ sqlType("INT") 		//оплаты
				//+", FSF_SUM "+ sqlType("DOUBLE")//сумма начислений
				//+", FPV_SUM "+ sqlType("DOUBLE")//сумма оплат
				//+", FBALANCE "+ sqlType("DOUBLE")//баланс
				+", FDOCS "+ sqlType("INT") 	//все документы
				+")";
	ExecuteSQL(sSQL, false);
	ExecuteSQL("delete from "+ sTmpTbl);
	
	sSQL = "insert into "+ sTmpTbl 
				  +" (FORG, FWID, FTXT, FADDR, FBLD, FAPART, FEMAIL, FPHONE)"
			+" select FCOD, FWID, FTXT, FADDR, FBLD, FAPART, FEMAIL, FPHONE"
			+" from ^LISTCLORG"
			+" where FCL=0 and FCOD>0";
	ExecuteSQL(sSQL);
	
	createIndex(sTmpTbl, "FORG", "FORG");
	createIndex(sTmpTbl, "FWID", "FWID");
	
	//calcSum();
}

function recalc()
{
	calcSum();
	//list.tblInit();
	Caption(list.subTitle());
	grid.getTable().requery();
	grid.refresh();	
}

function calcSum()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var sPr = UR("Виконується розрахунок...|Выполняется расчет...");
	var nPr = 1;
	setProgressRange(0, 20);
	setProgressPos(nPr++, sPr);
	
	var sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG=t.FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG="+ sTmpTbl +".FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_IN=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG=t.FORG "
						+" and tel.FTYPE=1"
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_IN=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG="+ sTmpTbl +".FORG "
						+" and tel.FTYPE=1"
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_TIME=(select sum(tel.FTIME) as FTIME"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG=t.FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_TIME=(select sum(tel.FTIME) as FTIME"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG="+ sTmpTbl +".FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTALK_TIME=0 where FTALK_TIME is NULL");
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_SUM=(select sum(tel.FSUM) as FSUM"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG=t.FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_SUM=(select sum(tel.FSUM) as FSUM"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FORG="+ sTmpTbl +".FORG "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTALK_SUM=0 where FTALK_SUM is NULL");
	setProgressPos(nPr++, sPr);
	
	var sTmpMailCnt = getTmpTableName();
	sSQL = "select msg.*, cnt.FID_CP"
			+" into "+ sTmpMailCnt 
			+" from ^MAIL_CNT cnt "
				+" inner join ^MAIL_MSG msg on msg.FWID=cnt.FID_DOC "				
			+" where cnt.FID_CP in (select FWID from "+ sTmpTbl +")"
				+" or cnt.FID_CP in (select cp.FWID "
					+" from ^CL_ORGCP cp "
					+" where cp.FWID_CL in (select FWID from "+ sTmpTbl +")"
					+")";					
	ExecuteSQL(sSQL);
	
	sSQL = "update "+ sTmpTbl +" t set t.FMAIL=(select count(*) as FMAIL"
			+" from "+ sTmpMailCnt +" cnt where (cnt.FID_CP=t.FWID"
					+" or cnt.FID_CP=(select max(cp.FWID) from ^CL_ORGCP cp where cp.FWID_CL=t.FWID))"
				+" and cnt.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2)
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl +" set FMAIL=(select count(*) as FMAIL"
			+" from "+ sTmpMailCnt +" cnt where (cnt.FID_CP="+ sTmpTbl +".FWID"
					+" or cnt.FID_CP=(select max(cp.FWID) from ^CL_ORGCP cp where cp.FWID_CL="+ sTmpTbl +".FWID))"
				+" and cnt.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2)
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t set t.FMAIL_IN=(select count(*) as FMAIL_IN"
			+" from "+ sTmpMailCnt +" cnt where (cnt.FID_CP=t.FWID"
					+" or cnt.FID_CP=(select max(cp.FWID) from ^CL_ORGCP cp where cp.FWID_CL=t.FWID))"
				+" and cnt.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2)					
				+" and (cnt.FTYPE=2 or cnt.FTYPE=3 or cnt.FNOP="+ getPar("POP3_DOC") +")"
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl +" set FMAIL_IN=(select count(*) as FMAIL_IN"
			+" from "+ sTmpMailCnt +" cnt where (cnt.FID_CP="+ sTmpTbl +".FWID"
					+" or cnt.FID_CP=(select max(cp.FWID) from ^CL_ORGCP cp where cp.FWID_CL="+ sTmpTbl +".FWID))"
				+" and cnt.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2)					
				+" and (cnt.FTYPE=2 or cnt.FTYPE=3 or cnt.FNOP="+ getPar("POP3_DOC") +")"
			+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("drop table "+ sTmpMailCnt);
	setProgressPos(nPr++, sPr);
	
		
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FPOST=(select count(*) as cnt"
			+" from ^POST p where (p.FSENDER=t.FORG or p.FRECIPIENT=t.FORG)"
				+" and p.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FPOST=(select count(*) as cnt"
				+" from ^POST p"
				+" where (p.FSENDER="+ sTmpTbl +".FORG"
					+" or p.FRECIPIENT="+ sTmpTbl +".FORG)"
				+" and p.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FPOST_IN=(select count(*) as cnt"
			+" from ^POST p where (p.FSENDER=t.FORG)"
				+" and p.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FPOST_IN=(select count(*) as cnt"
			+" from ^POST p where (p.FSENDER="+ sTmpTbl +".FORG)"
				+" and p.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FCALL=(select count(*) as cnt"
			+" from ^CALL c where c.FCUSTOMER=t.FORG"
				+" and c.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FCALL=(select count(*) as cnt"
			+" from ^CALL c where c.FCUSTOMER="+ sTmpTbl +".FORG"
				+" and c.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK=(select count(*) as cnt"
			+" from ^TASK tsk where tsk.FCUSTOMER=t.FORG"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK=(select count(*) as cnt"
			+" from ^TASK tsk where tsk.FCUSTOMER="+ sTmpTbl +".FORG"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK_EXEC=(select count(*) as cnt"
			+" from ^TASK tsk "
			+"where tsk.FCUSTOMER=t.FORG"
				+" and tsk.FPROCENTVIPOLN=100"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK_EXEC=(select count(*) as cnt"
			+" from ^TASK tsk "
			+"where tsk.FCUSTOMER="+ sTmpTbl +".FORG"
				+" and tsk.FPROCENTVIPOLN=100"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK_TIME=(select sum(tsk.FTIMEVIPOLN) as FTIMEVIPOLN"
			+" from ^TASK tsk "
			+" where tsk.FCUSTOMER=t.FORG"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK_TIME=(select sum(tsk.FTIMEVIPOLN) as FTIMEVIPOLN"
			+" from ^TASK tsk "
			+" where tsk.FCUSTOMER="+ sTmpTbl +".FORG"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTASK_TIME=0 where FTASK_TIME is NULL");
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FSF=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG=t.FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and UPPER(c.HDOC)='SF'"
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FSF=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG="+ sTmpTbl +".FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and UPPER(c.HDOC)='SF'"
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
		
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FPV=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG=t.FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and c.FSUM_OPL>0"
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FPV=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG="+ sTmpTbl +".FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and c.FSUM_OPL>0"
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FML=(select count(*) as cnt"
			+" from ^HML h where h.FWID in (select r.FID_DOC from ^RML r where r.FORG=t.FORG)"
				+" and h.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FML=(select count(*) as cnt"
			+" from ^HML h where h.FWID in (select r.FID_DOC from ^RML r where r.FORG="+ sTmpTbl +".FORG)"
				+" and h.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FRESPONSE=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FORG=t.FORG"
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FRESPONSE=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FORG="+ sTmpTbl +".FORG"
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTOPIC=(select count(*) as cnt"
			+" from ^TOPICS tpc where tpc.FORG=t.FORG"
				+" and tpc.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTOPIC=(select count(*) as cnt"
			+" from ^TOPICS tpc where tpc.FORG="+ sTmpTbl +".FORG"
				+" and tpc.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FDOCS=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG=t.FORG"
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FDOCS=(select count(*) as cnt"
			+" from ^LISTDOCCRM c where c.HORG="+ sTmpTbl +".FORG"
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	ExecuteSQL("update "+ sTmpTbl +" set FTALK=0 where FTALK is NULL");
	ExecuteSQL("update "+ sTmpTbl +" set FMAIL=0 where FMAIL is NULL");
	ExecuteSQL("update "+ sTmpTbl +" set FPOST=0 where FPOST is NULL");
	ExecuteSQL("update "+ sTmpTbl +" set FRATING=(FTALK+FMAIL+FPOST)");
	
	setProgressPos(0);
}

function date_valid()
{
	TYPEPER.value = "";
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	//list.recalc();
}

include("sys/DpList.js");