include("Objects/DpGetDat.js");
include("Objects/DpGrid.js");
include("Objects/DpCl.js");
include("servis/format.js");
include("servis/date.js");

var sTmpTbl = getTmpTableName();
var label = "CRM_BALANCE";
var oOrg;

function listLoad()
{
	this.title = UR("Баланс контрагентів|Баланс контрагентов");
	this.xmlGridFile = "orgbalance.xml";
	this.printLabel = label;
	
	oOrg = new DpCl("0", getPar("CODPLAT"), 0);
	oOrg.linkSmartCtrl(FORG);
	oOrg.setContAssist();
	oOrg.AfterUpdate = orgUpdate;
	if(extPar.org)
		this.oOrg.setCod(extPar.org);
	
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	if(extPar.date)
	{
		DATB.value = extPar.date;
		DATE.value = extPar.date;
	}
	
	this.recalc = recalc;
	setButton(BTNRECALC, this, "recalc");
	setValid(TYPEPER, onChangePeriod);
	setValid(DATB, date_valid);
	setValid(DATE, date_valid);
}

function listTitle()
{
	var sTitle = UR("Баланс контрагентів|Баланс контрагентов");
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	if(differ(dat1, new Date(1900, 0, 1))>0 && differ(dat1, d00)<0)
	{
		var sType = String(TYPEPER.value).trim();
		if(differ(dat1, dat2)==0)
			sTitle += " за "+ format("dd mmm yyyy", dat1);
		else if(sType=="TM" || sType=="LM")
			sTitle += " за "+ format("Mmm yyyy", dat1).toLowerCase();
		else if(sType=="TY")
			sTitle += " за "+ format("yyyy", dat1) + UR("р|г");
		else
			sTitle += ": "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");	
	}
	this.title = sTitle;
	return sTitle;
}

function orgUpdate()
{
	list.qryWhere = "1=1";
	if(oOrg.getCod())
		list.qryWhere = "FORG="+ oOrg.getCod();
	list.tblInit();
}

function listSrc()
{	
	this.qrySet("From", sTmpTbl
				, "Order", "FORG"
				);	
}

function listDelAcc()
{
	return false;
}

function listMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		grid.AddMenuItem("VIEW", "Зведена інформація|Сводная информация");
	}
}

function listMenuRun(sID)
{
	var tbl = grid.getTable();
	if(!tbl)
		return;
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="VIEW" || sID=="EDIT")
	{
		var par =  new Object()
		par.org = tbl.getValue("FORG");	
		par.Fcl = 0;	
		showWindow("l_cl_info.xml", SW_MODAL, par);
	}	
}

function listMake()
{
	var sSQL = "create table "+ sTmpTbl 
				+" (FORG "+ sqlType("LONG") 
				+", FWID "+ sqlType("LONG")
				+", FTXT "+ sqlType("LONGTEXT")
				+", FADDR "+ sqlType("TEXT")
				+", FBLD "+ sqlType("TEXT")
				+", FAPART "+ sqlType("TEXT")
				+", FEMAIL "+ sqlType("TEXT")
				+", FPHONE "+ sqlType("TEXT")
				+", FSF_SUM "+ sqlType("DOUBLE")	//сумма начислений
				+", FPV_SUM "+ sqlType("DOUBLE")	//сумма оплат
				+", FBALANCE "+ sqlType("DOUBLE")	//баланс
				+")";
	ExecuteSQL(sSQL, false);
	ExecuteSQL("delete from "+ sTmpTbl);
	
	sSQL = "insert into "+ sTmpTbl 
				  +" (FORG, FWID, FTXT, FADDR, FBLD, FAPART, FEMAIL, FPHONE)"
			+" select FCOD, FWID, FTXT, FADDR, FBLD, FAPART, FEMAIL, FPHONE"
			+" from ^LISTCLORG"
			+" where FCL=0 and FCOD>0";
	ExecuteSQL(sSQL);	
	createIndex(sTmpTbl, "FORG", "FORG");
	createIndex(sTmpTbl, "FWID", "FWID");
	
	//calcSum();
}

function recalc()
{
	calcSum();
	//list.tblInit();
	Caption(list.subTitle());
	grid.getTable().requery();
	grid.refresh();	
}

function calcSum()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
			
	var sSQL = "update "+ sTmpTbl +" t"
			+" set t.FSF_SUM=(select sum(c.FSUM_VYK) "
			+" from ^LISTDOCCRM c where c.HORG=t.FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FSF_SUM=(select sum(c.FSUM_VYK) "
			+" from ^LISTDOCCRM c where c.HORG="+ sTmpTbl +".FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FPV_SUM=(select sum(c.FSUM_OPL) "
			+" from ^LISTDOCCRM c where c.HORG=t.FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FPV_SUM=(select sum(c.FSUM_OPL) "
			+" from ^LISTDOCCRM c where c.HORG="+ sTmpTbl +".FORG"				
				+" and c.HDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	
	ExecuteSQL("update "+ sTmpTbl +" set FSF_SUM=0 where FSF_SUM is NULL");
	ExecuteSQL("update "+ sTmpTbl +" set FPV_SUM=0 where FPV_SUM is NULL");
	ExecuteSQL("update "+ sTmpTbl +" set FBALANCE=(FSF_SUM-FPV_SUM)");
}

function date_valid()
{
	TYPEPER.value = "";
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	//list.recalc();
}

include("sys/DpList.js");