include("Objects/DpClEx.js");
include("Objects/DpCl.js");
include("servis/format.js");

var sTmpTbl = getTmpTableName();
var label = "CRM_PRODUCTIVITY";
var oMngr;

function listLoad()
{
	this.title = UR("Продустивність персоналу|Продуктивность персонала");
	this.xmlGridFile = "productivity.xml";
	this.printLabel = label;
	
	oMngr = new DpCl("0", getPar("CODPERS"), 0);
	oMngr.linkSmartCtrl(FMANAGER);
	oMngr.setContAssist();
	oMngr.AfterUpdate = managerUpdate;	
	
	DATB.value = getPar("GLOBDAT1");
	DATE.value = getPar("GLOBDAT2");
	if(extPar.date)
	{
		DATB.value = extPar.date;
		DATE.value = extPar.date;
	}
	
	this.recalc = recalc;
	setButton(BTNRECALC, this, "recalc");
	setValid(TYPEPER, onChangePeriod);
	setValid(DATB, date_valid);
	setValid(DATE, date_valid);
}

function listTitle()
{
	var sTitle = UR("Продустивність персоналу|Продуктивность персонала");
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	if(differ(dat1, new Date(1900, 0, 1))>0 && differ(dat1, d00)<0)
	{
		var sType = String(TYPEPER.value).trim();
		if(differ(dat1, dat2)==0)
			sTitle += " за "+ format("dd mmm yyyy", dat1);
		else if(sType=="TM" || sType=="LM")
			sTitle += " за "+ format("Mmm yyyy", dat1).toLowerCase();
		else if(sType=="TY")
			sTitle += " за "+ format("yyyy", dat1) + UR("р|г");
		else
			sTitle += ": "+ StrDat(dat1, "DMY") +" - "+ StrDat(dat2, "DMY");	
	}
	this.title = sTitle;
	return sTitle;
}

function listSrc()
{	
	this.qrySet("From", sTmpTbl
				, "Order", "FMANAGER"
				);	
}

function managerUpdate()
{
	list.qryWhere = "1=1";
	if(oMngr.getCod())
		list.qryWhere = "FMANAGER="+ oMngr.getCod();
	list.tblInit();
}


function listDelAcc()
{
	return false;
}

function listMenuInit()
{
	var tbl = grid.getTable();
	if(!tbl.isEmpty())
	{
		var org = Number(tbl.getValue("FORG"));
		grid.AddMenuItem("ORG", "Контрагенти \t("+ org +")|Контрагенты \t("+ org +")", org==0);
		var contact = Number(tbl.getValue("FCONTACT"));
		grid.AddMenuItem("CONTACT", "Контакти \t("+ contact +")|Контакты \t("+ contact +")", contact==0);
		var task = Number(tbl.getValue("FTASK"));
		grid.AddMenuItem("TASK", "Завдання \t("+ task +")|Задания \t("+ task +")", task==0);
		var call = Number(tbl.getValue("FCALL"));
		grid.AddMenuItem("CALL", "Заявки \t("+ call +")|Заявки \t("+ call +")", call==0);
		var talk = Number(tbl.getValue("FTALK"));
		grid.AddMenuItem("TALK", "Телефонні розмови \t("+ talk +")|Телефеонные разговоры \t("+ talk +")", talk==0);				
		var topic = Number(tbl.getValue("FTOPIC"));
		grid.AddMenuItem("TOPIC", "Теми \t("+ topic +")|Темы \t("+ topic +")", topic==0);
		var ml = Number(tbl.getValue("FML"));
		grid.AddMenuItem("ML", "Маркетингові списки \t("+ ml +")|Маркетинговые списки \t("+ ml +")", ml==0);
		var response = Number(tbl.getValue("FRESPONSE"));
		grid.AddMenuItem("RESPONSE", "Відгуки \t("+ response +")|Отклики \t("+ response +")", response==0);
		var docs = Number(tbl.getValue("FDOCS"));
		grid.AddMenuItem("DOCS", "Усі документи \t("+ docs +")|Все документы \t("+ docs +")", docs==0);
		grid.AddMenuItem("", "");
		grid.AddMenuItem("VIEW", "Перегляд|Просмотр");
	}
}

function listMenuRun(sID)
{
	var tbl = grid.getTable();
	if(!tbl)
		return;
	setPar("GLOBDAT1", DATB.value);
	setPar("GLOBDAT2", DATE.value);
	var manager = tbl.getValue("FMANAGER");
	var tblName = tbl.getTableName();	
	var rowID = Number(tbl.getValue("FWID"));
	if(sID=="VIEW" || sID=="EDIT")
	{
		var par = new Object();
		var oCl =  new DpClEx("CL3", Number(getPar("CODPERS")));
		oCl.edit("VIEW", rowID);
		return true;
	}
	else if(sID=="ORG")
	{
		var par =  new Object();
		par.Fcl = 0;
		par.subWhere = " FWID in (select cp.FWID_CL from ^CL_ORGCP cp where cp.FMANAGER="+ manager +")";
		showWindow("l_cl.xml", SW_NOMODAL, par);
	}
	else if(sID=="CONTACT")
	{
		var par =  new Object();
		par.subWhere = " FMANAGER="+ manager;
		showWindow("l_cnt.js", SW_NOMODAL, par);
	}
	else if(sID=="TASK")
	{
		var par =  new Object();
		par.doc = "TASK";
		par.programmer = manager;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="CALL")
	{
		var par =  new Object();
		par.doc = "CALL";
		par.executor = manager;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="TALK")
	{
		var par =  new Object();
		par.doc = "CRM.TR";
		par.org = 0;
		par.manager = manager;			
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="TOPIC")
	{
		var par =  new Object();
		par.doc = "TOPIC";
		par.manager = manager;
		par.subWhere = " FMANAGER="+ manager;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="ML")
	{
		var par =  new Object();
		par.doc = "ML";
		par.manager = manager;
		par.subWhere = " FMANAGER="+ manager;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="RESPONSE")
	{
		var par =  new Object();
		par.doc = "RESPONSE";
		par.manager = manager;
		par.subWhere = " FMANAGER="+ manager;
		showWindow("l_docekz.xml", SW_NOMODAL, par);
	}
	else if(sID=="DOCS")
	{
		var par =  new Object();		
		par.user = tbl.getValue("FUSER");
		par.JID = "CRM";
		par.subWhere = " HID_DOC in (select FID_DOC from ^ARCHIVE where FMACTION='A' and FMUSER="+ sqlTo(par.user) +")";		
		showWindow("l_crm.xml", SW_NOMODAL, par);
	}
}

function listMake()
{
	var sSQL = "create table "+ sTmpTbl 
				+" (FMANAGER "+ sqlType("LONG")
				+", FWID "+ sqlType("LONG")
				+", FUSER "+ sqlType("TEXT")
				+", FTXT "+ sqlType("LONGTEXT")				
				+", FEMAIL "+ sqlType("TEXT")
				+", FPHONE "+ sqlType("TEXT")
				+", FORG "+ sqlType("INT")
				+", FCONTACT "+ sqlType("INT")
				+", FTASK "+ sqlType("INT") 	//задания
				+", FTASK_EXEC "+ sqlType("INT")//задания выполненные
				+", FTASK_TIME "+ sqlType("DOUBLE")//время выполнения
				+", FCALL "+ sqlType("INT") 	//заявки
				+", FTALK "+ sqlType("INT") 	//телефонные разговоры
				+", FTALK_IN "+ sqlType("INT") 	//телефонные разговоры входящие
				+", FTALK_TIME "+ sqlType("INT")//время телефонных разговоров
				+", FTALK_SUM "+ sqlType("DOUBLE")//сумма телефонных разговоров				
				+", FTOPIC "+ sqlType("INT") 	//топики
				+", FML "+ sqlType("INT") 		//маркетинговые списки
				+", FRESPONSE "+ sqlType("INT") //отклики
				+", FRESPONSEP "+ sqlType("INT")//положительные отклики
				+", FRESPONSEN "+ sqlType("INT")//отрицательные отклики
				+", FDOCS "+ sqlType("INT")		//все документы				
				+", FRATING "+ sqlType("INT")
				+")";
	ExecuteSQL(sSQL, false);
	ExecuteSQL("delete from "+ sTmpTbl);
	
	sSQL = "insert into "+ sTmpTbl 
				  +" (FMANAGER, FWID, FTXT, FEMAIL, FPHONE)"
			+" select FCOD, FWID, FTXT, FEMAIL, FWRKPHONE"
			+" from ^LISTCL3"
			+" where FCL="+ getPar("CODPERS") +" and FCOD>0";
	ExecuteSQL(sSQL);
	
	createIndex(sTmpTbl, "FMANAGER", "FMANAGER");
	createIndex(sTmpTbl, "FWID", "FWID");
	
	//calcSum();
}

function recalc()
{
	calcSum();
	Caption(list.subTitle());
	grid.getTable().requery();
	grid.refresh();	
}

function calcSum()
{
	var dat1 = DATB.value;
	var dat2 = DATE.value;
	var sPr = UR("Виконується розрахунок...|Выполняется расчет...");
	var nPr = 1;
	setProgressRange(0, 21);
	setProgressPos(nPr++, sPr);
	
	var sSQL = "update "+ sTmpTbl +" t"
			+" set t.FORG=(select count(*) as cnt"
				+" from ^LISTCLORG org"
				+" where org.FCL=0 and FWID in (select cp.FWID_CL"
						+" from ^CL_ORGCP cp"
						+" where cp.FWID_CL=org.FWID"
							+" and cp.FMANAGER=t.FMANAGER)"
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FORG=(select count(*) as cnt"
				+" from ^LISTCLORG org"
				+" where org.FCL=0 and FWID in (select cp.FWID_CL"
						+" from ^CL_ORGCP cp"
						+" where cp.FWID_CL=org.FWID"
							+" and cp.FMANAGER="+ sTmpTbl +".FMANAGER)"
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FCONTACT=(select count(*) as cnt"
				+" from ^CL_ORGCP cp"
				+" where cp.FMANAGER=t.FMANAGER"
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FCONTACT=(select count(*) as cnt"
				+" from ^CL_ORGCP cp"
				+" where cp.FMANAGER="+ sTmpTbl +".FMANAGER"
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK=(select count(*) as cnt"
			+" from ^TASK tsk where tsk.FPROGRAMMER=t.FMANAGER"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK=(select count(*) as cnt"
			+" from ^TASK tsk where tsk.FPROGRAMMER="+ sTmpTbl +".FMANAGER"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);	
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK_EXEC=(select count(*) as cnt"
			+" from ^TASK tsk "
			+"where tsk.FPROGRAMMER=t.FMANAGER"
				+" and tsk.FPROCENTVIPOLN=100"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK_EXEC=(select count(*) as cnt"
			+" from ^TASK tsk "
			+"where tsk.FPROGRAMMER="+ sTmpTbl +".FMANAGER"
				+" and tsk.FPROCENTVIPOLN=100"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTASK_TIME=(select sum(tsk.FTIMEVIPOLN) as FTIMEVIPOLN"
			+" from ^TASK tsk "
			+" where tsk.FPROGRAMMER=t.FMANAGER"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTASK_TIME=(select sum(tsk.FTIMEVIPOLN) as FTIMEVIPOLN"
			+" from ^TASK tsk "
			+" where tsk.FPROGRAMMER="+ sTmpTbl +".FMANAGER"
				+" and tsk.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTASK_TIME=0 where FTASK_TIME is NULL");
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FCALL=(select count(*) as cnt"
			+" from ^CALL c where c.FEXECUTOR=t.FMANAGER"
				+" and c.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FCALL=(select count(*) as cnt"
			+" from ^CALL c where c.FEXECUTOR="+ sTmpTbl +".FMANAGER"
				+" and c.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER=t.FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER="+ sTmpTbl +".FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_IN=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER=t.FMANAGER "
						+" and tel.FTYPE=1"
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_IN=(select count(*) as cnt"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER="+ sTmpTbl +".FMANAGER "
						+" and tel.FTYPE=1"
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_TIME=(select sum(tel.FTIME) as FTIME"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER=t.FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_TIME=(select sum(tel.FTIME) as FTIME"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER="+ sTmpTbl +".FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTALK_TIME=0 where FTALK_TIME is NULL");
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTALK_SUM=(select sum(tel.FSUM) as FSUM"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER=t.FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTALK_SUM=(select sum(tel.FSUM) as FSUM"
				+" from ^CRM_TELRAZG tel"
					+" where tel.FMANAGER="+ sTmpTbl +".FMANAGER "
						+" and tel.FDOC_DAT between "+ sqlTo(dat1) 
							+" and "+ sqlTo(dat2) 
				+")";
	ExecuteSQL(sSQL);
	ExecuteSQL("update "+ sTmpTbl +" set FTALK_SUM=0 where FTALK_SUM is NULL");
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FTOPIC=(select count(*) as cnt"
			+" from ^TOPICS tpc where tpc.FMANAGER=t.FMANAGER"
				+" and tpc.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FTOPIC=(select count(*) as cnt"
			+" from ^TOPICS tpc where tpc.FMANAGER="+ sTmpTbl +".FMANAGER"
				+" and tpc.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FML=(select count(*) as cnt"
			+" from ^HML h where h.FMANAGER=t.FMANAGER"
				+" and h.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FML=(select count(*) as cnt"
			+" from ^HML h where h.FMANAGER="+ sTmpTbl +".FMANAGER"
				+" and h.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FRESPONSE=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER=t.FMANAGER"
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FRESPONSE=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER="+ sTmpTbl +".FMANAGER"
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FRESPONSEP=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER=t.FMANAGER"				
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and resp.FCONFIRM=1"
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FRESPONSEP=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER="+ sTmpTbl +".FMANAGER"				
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and resp.FCONFIRM=1"
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FRESPONSEN=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER=t.FMANAGER"				
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and resp.FCONFIRM=2"
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FRESPONSEN=(select count(*) as cnt"
			+" from ^RESPONSE resp where resp.FMANAGER="+ sTmpTbl +".FMANAGER"				
				+" and resp.FDOC_DAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
				+" and resp.FCONFIRM=2"
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FUSER=(select pers.FLOGIN as FLOGIN"
						+" from ^CL_PERS pers"
						+" where pers.FWID_CL=t.FWID"
						+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FUSER=(select pers.FLOGIN as FLOGIN"
						+" from ^CL_PERS pers"
						+" where pers.FWID_CL="+ sTmpTbl +".FWID"
						+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);	
	
	sSQL = "update "+ sTmpTbl +" t"
			+" set t.FDOCS=(select count(*) as cnt"
			+" from ^ARCHIVE a"
			+" inner join ^LISTDOCCRM c on c.HID_DOC=a.FID_DOC"
			+" where a.FMUSER=t.FUSER"
				+" and a.FMACTION='A'"
				+" and a.FDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	if(SUBD==MSSQL || SUBD == POSTGRE)
		sSQL = "update "+ sTmpTbl
			+" set FDOCS=(select count(*) as cnt"
			+" from ^ARCHIVE a"
			+" inner join ^LISTDOCCRM c on c.HID_DOC=a.FID_DOC"
			+" where a.FMUSER="+ sTmpTbl +".FUSER"
				+" and a.FMACTION='A'"
				+" and a.FDAT between "+ sqlTo(dat1) +" and "+ sqlTo(dat2) 
			+")";
	ExecuteSQL(sSQL);
	setProgressPos(nPr++, sPr);
	
	ExecuteSQL("update "+ sTmpTbl +" set FRATING=FDOCS");
	
	setProgressPos(0);
}

function date_valid()
{
	TYPEPER.value = "";
}

function onChangePeriod()
{
	var per = String(TYPEPER.value);
	switch (per)
	{
		case "TD":
			DATB.value = today.getVarDate();
			DATE.value = today.getVarDate();
			break;
		case "YTD":
			DATB.value = goDay(today, -1);
			DATE.value = goDay(today, -1);
			break;
		case "TW":
			DATB.value = goDay(today, -today.getDay());
			DATE.value = goDay(today,6 - today.getDay());
			break;
		case "TM":
			DATB.value = firstDayMonth(today);
			DATE.value = lastDayMonth(today);
			break;
		case "LM":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(_dateTrans(today, "M+", -1));
			break;
		case "2M":
			DATB.value = firstDayMonth(_dateTrans(today, "M+", -1));
			DATE.value = lastDayMonth(today);
			break;		
		case "TY":
			DATB.value = jan01(today);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "2Y":
			var bdat = new Date(today.getFullYear()-1, today.getMonth());
			DATB.value = jan01(bdat);
			DATE.value = _dateTrans(today, "D=", 31, "M=", 12);;
			break;
		case "ALL":
			DATB.value = d00min;
			DATE.value = d00;
			break;
		default:
			break;
	}
	//list.recalc();
}

include("sys/DpList.js");